'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.mouse = mouse;
exports.key = key;
exports.any = any;
var BUTTONS = {
  LEFT: 1,
  RIGHT: 2,
  MIDDLE: 4,
  BACK: 8,
  FORWARD: 16
};

var BUTTON_NAMES = ['left', 'middle', 'right', 'back', 'forward'];

function hasButton(code, value) {
  return (value | code) === value;
}

function modifiers(ev) {
  var names = [];
  if (ev.ctrlKey) names.push('ctrl');
  if (ev.altKey) names.push('alt');
  if (ev.shiftKey) names.push('shift');
  if (ev.metaKey) names.push('meta');
  return names;
}

function mouse(ev) {
  var names = modifiers(ev);
  var b = ev.buttons;

  if (b) {
    for (var _name in BUTTONS) {
      if ((b | BUTTONS[_name]) === b) {
        names.push(_name.toLowerCase());
      }
    }
  } else {
    names.push(BUTTON_NAMES[ev.button]);
  }

  return names.join('+');
}

function key(ev) {
  var names = modifiers(ev);

  if (typeof ev.charCode !== 'undefined') {
    names.push(String.fromCharCode(ev.charCode));
  }

  return names.join('+');
}

function any(ev) {
  if (ev.buttons || ev.button) {
    return 'mouse:' + mouse(ev);
  }if (typeof ev.keyIdentifier !== 'undefined') {
    return 'key:' + key(ev);
  }return false;
}